var getFramesHtml = (function() {

    function getAllChildDocuments(doc) {
        var result = [doc];
        var iframes = doc.getElementsByTagName('iframe');
        if(iframes.length<1){
            iframes = doc.getElementsByTagName('frame');
        }
        for (var i = 0, j = iframes.length; i < j; i++) {
            result = result.concat(getAllChildDocuments(iframes[i].contentWindow.document))
        }
        return result;
    }

    var curIndex = 0;
    var frames = getAllChildDocuments(document);
    var length = frames.length;

    return function() {
        if (curIndex < length) {
            return {
                html: frames[curIndex].body.innerHTML,
                hasNext: ++curIndex < length
            }
        } else {
            return {
                html: '',
                hasNext: false
            }
        }
    }
})();